#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "double_game.h"
#include "turnoff.h"
#include "turnon.h"
#include "display.h"

/* COLOURS*/
#define RED 1
#define GREEN 2
#define BLUE 3
#define PURPLE 4

/* DOUBLE GAME MACROS */
#define DRED PC1
#define DBLUE PD1
#define DGET PD0

#define FALSE 0
#define TRUE 1

int double_game(int money)
{
	uint8_t red_old = 0xff;
	uint8_t blue_old = 0xff;
	uint8_t get_old = 0xff;

	int result = -1, count = 0;
	int red_pushed = 0, blue_pushed = 0;
	int chosen_colour = -1, right_colour = -1;
	int in_game = 1;
	
	turnOffTheLEDs();
	while (1)
	{	
		uint8_t red_crt = PINC;
		uint8_t blue_crt = PIND;
		uint8_t get_crt = PIND;
		
		right_colour = rand() % 4603 % 2;
		
		if (chosen_colour != -1)
		{
			turnOffTheLEDs();
			if (right_colour == 0)
			{
				turnOffTheLEDs();
				tonLED23(RED);
			}
			else
			{
				if (right_colour == 1)
				{
					turnOffTheLEDs();
					tonLED23(BLUE);
				}
			}
			
			result = display_double_game_result(right_colour, chosen_colour);
			if (result == 0)
			{
				money = 0;
				break;
			}
			else
			{
				if (result == 1)
				{
					money *= 2;
					chosen_colour = -1;
					right_colour = -1;
					in_game = 1;
					if (count == 5)
					{
						break;
					}
				}
			}
		}
		
		if (chosen_colour == -1)
		{
			if (in_game == 1)
			{
				display_double_game();
				in_game = 0;
			}
			turnOffTheLEDs();
			_delay_ms(5);
			tonLED22(RED);
			_delay_ms(300);
			toffLED22(RED);
			tonLED24(BLUE);
			_delay_ms(300);
			toffLED24(BLUE);
		}
		_delay_ms(5);
		
		/* CHOOSE RED*/
		if ((red_old & (1 << DRED)) && !(red_crt & (1 << DRED)))
		{
			red_pushed = TRUE;
		}
		
		if (red_pushed == TRUE)
		{
			chosen_colour = 0;//RED
			count++;
		}
		
		red_pushed = FALSE;
		red_old = red_crt;
		_delay_ms(5);
		
		/* CHOOSE BLUE */
		if ((blue_old & (1 << DBLUE)) && !(blue_crt & (1 << DBLUE)))
		{
			blue_pushed = TRUE;
		}
		
		if (blue_pushed == TRUE)
		{
			chosen_colour = 1;//BLUE
			count++;
		}
		
		blue_pushed = FALSE;
		blue_old = blue_crt;
		_delay_ms(5);
		
		/* GET MONEY  */
		if ((get_old & (1 << DGET)) && !(get_crt & (1 << DGET)))
		{
			break;
		}
	}
	turnOffTheLEDs();
	return money;
}