#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "game.h"
#include "turnon.h"
#include "forms.h"

void rand_matrix(int** matrix)
{
	int i = 0, j = 0;
	int r = 0;
	for (i = 0; i < 5; i++)
	{
		for (j = 0; j < 3; j++)
		{
			r = rand() % 4;
			matrix[i][j] = r + 1;
		}
	}
}

int* set_vector(int c1, int c2, int c3, int c4, int c5)
{
	int* v = malloc(5 * sizeof(int));
	
	if (v == NULL)
		return NULL;
	
	v[0] = c1;
	v[1] = c2;
	v[2] = c3;
	v[3] = c4;
	v[4] = c5;
	
	return v;
}

int x_factor(int** matrix)
{
	int lucky = 0, factor = 0;
	
	int* v_form_vect = set_vector(0, 1, 2, 1, 0);
	int* a_form_vect = set_vector(2, 1, 0, 1, 2);
	int* line1_form_vect = set_vector(2, 2, 2, 2, 2);
	int* line2_form_vect = set_vector(1, 1, 1, 1, 1);
	int* line3_form_vect = set_vector(0, 0, 0, 0, 0);	
	int* line1_2_form_vect = set_vector(2, 2, 1, 2, 2);	
	int* line3_2_form_vect = set_vector(0, 0, 1, 0, 0);	
	int* line2_1_form_vect = set_vector(1, 2, 2, 2, 1);	
	int* line2_3_form_vect = set_vector(1, 0, 0, 0, 1);		
	
	lucky = check_form(matrix, v_form_vect);
	if (lucky != 0)
	{
		v_form(matrix, v_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, a_form_vect);
	if (lucky != 0)
	{
		a_form(matrix, a_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line1_form_vect);
	if (lucky != 0)
	{
		line1_form(matrix, line1_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line2_form_vect);
	if (lucky != 0)
	{
		line2_form(matrix, line2_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line3_form_vect);
	if (lucky != 0)
	{
		line3_form(matrix, line3_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line1_2_form_vect);
	if (lucky != 0)
	{
		line1_2_form(matrix, line1_2_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line3_2_form_vect);
	if (lucky != 0)
	{
		line3_2_form(matrix, line3_2_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line2_1_form_vect);
	if (lucky != 0)
	{
		line2_1_form(matrix, line2_1_form_vect);
		factor += lucky;
	}
	
	lucky = check_form(matrix, line2_3_form_vect);
	if (lucky != 0)
	{
		line2_3_form(matrix, line2_3_form_vect);
		factor += lucky;
	}
	
	free(v_form_vect);
	free(a_form_vect);
	free(line1_form_vect);
	free(line2_form_vect);
	free(line3_form_vect);
	free(line1_2_form_vect);
	free(line3_2_form_vect);
	free(line2_1_form_vect);
	free(line2_3_form_vect);
	
	return factor;
}

int roll_matrix(int** matrix)
{
	int i = 0, j = 0;
	int aux = 0;
	int r = rand() % 5;
	
	rand_matrix(matrix);

	for (i = 0; i < 5; i++)
	{
		for (j = 0; j < r; j++)
		{
			aux = matrix[i][2];
			matrix[i][2] = matrix[i][1];
			matrix[i][1] = matrix[i][0];
			matrix[i][0] = aux;
			switch (i)
			{
				case 0:
					blink_col1(matrix[i]);
					break;
				case 1:
					blink_col2(matrix[i]);
					break;
				case 2:
					blink_col3(matrix[i]);
					break;
				case 3:
					blink_col4(matrix[i]);
					break;
				case 4:
					blink_col5(matrix[i]);
					break;
			}
		}
	}
	_delay_ms(500);
	turnOnMatrix(matrix);
	
	return x_factor(matrix);
}